package gregapi.data;

import net.minecraft.util.EnumChatFormatting;
import gregapi.code.TagData;
import gregapi.lang.LanguageHandler;

/**
 * @author Gregorius Techneticies
 * 
 * Contains common translatable Strings.
 */
public class LH {
	public static final String
	  EFFICIENCY = "gt.lang.efficiency"
	, RECIPE = "gt.lang.recipe"
	, RECIPES = "gt.lang.recipes"
	, ENERGY_CONTAINED = "gt.lang.energy.contained"
	, ENERGY_CAPACITY = "gt.lang.energy.capacity"
	, ENERGY_OUTPUT = "gt.lang.energy.output"
	, ENERGY_INPUT = "gt.lang.energy.input"
	, CONVERTS_FROM_X = "gt.lang.energy.convert.from"
	, CONVERTS_TO_Y = "gt.lang.energy.convert.to"
	, CONVERTS_USING_Z = "gt.lang.energy.convert.using"
	, FACE_ANY = "gt.lang.face.any"
	, FACE_BOTTOM = "gt.lang.face.bottom"
	, FACE_TOP = "gt.lang.face.top"
	, FACE_LEFT = "gt.lang.face.left"
	, FACE_FRONT = "gt.lang.face.front"
	, FACE_RIGHT = "gt.lang.face.right"
	, FACE_BACK = "gt.lang.face.back"
	, FACE_SIDES = "gt.lang.face.sides"
	, FACE_ANYBUT_BOTTOM = "gt.lang.face.any.but.bottom"
	, FACE_ANYBUT_TOP = "gt.lang.face.any.but.top"
	, FACE_ANYBUT_LEFT = "gt.lang.face.any.but.left"
	, FACE_ANYBUT_FRONT = "gt.lang.face.any.but.front"
	, FACE_ANYBUT_RIGHT = "gt.lang.face.any.but.right"
	, FACE_ANYBUT_BACK = "gt.lang.face.any.but.back"
	, REQUIREMENT_AIR_IN_FRONT = "gt.lang.requirement.air.front"
	, REQUIREMENT_EMPTY_ASHES = "gt.lang.requirement.empty.ashes"
	, REQUIREMENT_IGNITE_FIRE = "gt.lang.requirement.ignite.fire"
	, REQUIREMENT_WATER = "gt.lang.requirement.water"
	, REQUIREMENT_WATER_ANY = "gt.lang.requirement.water.any"
	, REQUIREMENT_WATER_PURE = "gt.lang.requirement.water.pure"
	, REQUIREMENT_DISTILLED_WATER = "gt.lang.requirement.water.distilled"
	, EMITS_USED_STEAM = "gt.lang.emits.used.steam"
	, EMITS_REDSTONE_FLUX = "gt.lang.emits.redstoneflux.lossless"
	, EMITS_REDSTONE_FLUX_LOSS = "gt.lang.emits.redstoneflux.lossy"
	, ACCEPTS_REDSTONE_FLUX = "gt.lang.accepts.redstoneflux.lossless"
	, ACCEPTS_REDSTONE_FLUX_LOSS = "gt.lang.accepts.redstoneflux.lossy"
	, NO_GUI_CLICK_TO_INVENTORY = "gt.lang.nogui.rightclick.inventory"
	, NO_GUI_CLICK_TO_TANK = "gt.lang.nogui.rightclick.tank"
	, TOOL_TO_TOGGLE_SOFT_HAMMER = "gt.lang.use.soft.hammer.to.toggle"
	, TOOL_TO_HARVEST = "gt.lang.tool.to.harvest"
	, HAZARD_FIRE = "gt.lang.hazard.fire"
	, HAZARD_EXPLOSION_STEAM = "gt.lang.hazard.explosion.steam"
	, HAZARD_MELTDOWN = "gt.lang.hazard.meltdown"
	, TIME_TICK = "gt.lang.time.tick"
	, TIME_SEC = "gt.lang.time.second"
	, TIME_MIN = "gt.lang.time.minute"
	, TIME_HOUR = "gt.lang.time.hour"
	, TIME_DAY = "gt.lang.time.day"
	, TIME_WEEK = "gt.lang.time.week"
	, TIME_TICKS = "gt.lang.time.ticks"
	, TIME_SECS = "gt.lang.time.seconds"
	, TIME_MINS = "gt.lang.time.minutes"
	, TIME_HOURS = "gt.lang.time.hours"
	, TIME_DAYS = "gt.lang.time.days"
	, TIME_WEEKS = "gt.lang.time.weeks"
	;
	
	public static final void add(String aKey, String aEnglish) {LanguageHandler.add(aKey, aEnglish);}
	public static final String get(String aKey) {return LanguageHandler.translate(aKey);}
	
	public static final String getToolTipEfficiency(long aEfficiency) {return Chat.YELLOW + get(EFFICIENCY) + ": " + Chat.WHITE + (aEfficiency/100) +"."+ (aEfficiency%100) + "%";}
	
	public static final String getToolTipRedstoneFluxEmit(TagData aEnergyType) {
		if (aEnergyType == TD.Energy.KU) return Chat.ORANGE + LH.get(LH.EMITS_REDSTONE_FLUX_LOSS)+" 50%";
		if (aEnergyType == TD.Energy.RF) return Chat.ORANGE + LH.get(LH.EMITS_REDSTONE_FLUX);
		if (aEnergyType == TD.Energy.MJ) return Chat.ORANGE + LH.get(LH.EMITS_REDSTONE_FLUX);
		return null;
	}
	
	public static final String getToolTipRedstoneFluxAccept(TagData aEnergyType) {
		if (aEnergyType == TD.Energy.KU) return Chat.ORANGE + LH.get(LH.EMITS_REDSTONE_FLUX_LOSS)+" 50%";
		if (aEnergyType == TD.Energy.RF) return Chat.ORANGE + LH.get(LH.EMITS_REDSTONE_FLUX);
		if (aEnergyType == TD.Energy.MJ) return Chat.ORANGE + LH.get(LH.EMITS_REDSTONE_FLUX);
		return null;
	}
	
	static {
		add(EFFICIENCY						, "Efficiency");
		add(RECIPE							, "Recipe");
		add(RECIPES							, "Recipes");
		add(ENERGY_CONTAINED				, "Stored Energy");
		add(ENERGY_CAPACITY					, "Capacity");
		add(ENERGY_OUTPUT					, "Energy OUT");
		add(ENERGY_INPUT					, "Energy IN");
		add(CONVERTS_FROM_X					, "Converts");
		add(CONVERTS_TO_Y					, "into");
		add(CONVERTS_USING_Z				, "using");
		add(FACE_ANY						, "Any Side");
		add(FACE_BOTTOM						, "Bottom");
		add(FACE_TOP						, "Top");
		add(FACE_LEFT						, "Left");
		add(FACE_FRONT						, "Front");
		add(FACE_RIGHT						, "Right");
		add(FACE_BACK						, "Back");
		add(FACE_SIDES						, "Sides");
		add(FACE_ANYBUT_BOTTOM				, "Any but Bottom");
		add(FACE_ANYBUT_TOP					, "Any but Top");
		add(FACE_ANYBUT_LEFT				, "Any but Left");
		add(FACE_ANYBUT_FRONT				, "Any but Front");
		add(FACE_ANYBUT_RIGHT				, "Any but Right");
		add(FACE_ANYBUT_BACK				, "Any but Back");
		add(REQUIREMENT_AIR_IN_FRONT		, "Requires Air in front to work!");
		add(REQUIREMENT_EMPTY_ASHES			, "Requires Ashes to be extracted regularly!");
		add(REQUIREMENT_IGNITE_FIRE			, "Requires ignition by Flint and Tinder or similar!");
		add(REQUIREMENT_WATER				, "Requires input of Water");
		add(REQUIREMENT_WATER_ANY			, "Requires input of any Water");
		add(REQUIREMENT_WATER_PURE			, "Requires any Water. Use distilled Water for best efficiency!");
		add(REQUIREMENT_DISTILLED_WATER		, "Requires input of distilled Water");
		add(EMITS_USED_STEAM				, "Emits used Steam");
		add(EMITS_REDSTONE_FLUX				, "Can emit Redstone Flux (RF) losslessly");
		add(EMITS_REDSTONE_FLUX_LOSS		, "Can emit Redstone Flux (RF) with a Loss of");
		add(ACCEPTS_REDSTONE_FLUX			, "Can accept Redstone Flux (RF) losslessly");
		add(ACCEPTS_REDSTONE_FLUX_LOSS		, "Can accept Redstone Flux (RF) with a Loss of");
		add(NO_GUI_CLICK_TO_INVENTORY		, "No GUI, Click to insert/extract Items!");
		add(NO_GUI_CLICK_TO_TANK			, "No GUI, Click with Fluid Container to interact!");
		add(TOOL_TO_TOGGLE_SOFT_HAMMER		, "Use Soft Hammer to Toggle States");
		add(TOOL_TO_HARVEST					, "Tool to Harvest");
		add(HAZARD_FIRE						, "Can put Blocks around it on Fire!");
		add(HAZARD_EXPLOSION_STEAM			, "Explodes when Steam Pressure is too high!");
		add(HAZARD_MELTDOWN					, "Melts down when stored Heat is too much!");
		add(TIME_TICK						, "Tick");
		add(TIME_SEC						, "Second");
		add(TIME_MIN						, "Minute");
		add(TIME_HOUR						, "Hour");
		add(TIME_DAY						, "Day");
		add(TIME_WEEK						, "Week");
		add(TIME_TICKS						, "Ticks");
		add(TIME_SECS						, "Seconds");
		add(TIME_MINS						, "Minutes");
		add(TIME_HOURS						, "Hours");
		add(TIME_DAYS						, "Days");
		add(TIME_WEEKS						, "Weeks");
	}
	
	public static class Chat {
		public static final String
		  BLACK = EnumChatFormatting.BLACK.toString()
		, DBLUE = EnumChatFormatting.DARK_BLUE.toString()
		, DGREEN = EnumChatFormatting.DARK_GREEN.toString()
		, DCYAN = EnumChatFormatting.DARK_AQUA.toString()
		, DRED = EnumChatFormatting.DARK_RED.toString()
		, PURPLE = EnumChatFormatting.DARK_PURPLE.toString()
		, ORANGE = EnumChatFormatting.GOLD.toString()
		, GRAY = EnumChatFormatting.GRAY.toString()
		, DGRAY = EnumChatFormatting.DARK_GRAY.toString()
		, BLUE = EnumChatFormatting.BLUE.toString()
		, GREEN = EnumChatFormatting.GREEN.toString()
		, CYAN = EnumChatFormatting.AQUA.toString()
		, RED = EnumChatFormatting.RED.toString()
		, PINK = EnumChatFormatting.LIGHT_PURPLE.toString()
		, YELLOW = EnumChatFormatting.YELLOW.toString()
		, WHITE = EnumChatFormatting.WHITE.toString()
		, OBFUSCATED = EnumChatFormatting.OBFUSCATED.toString()
		, BOLD = EnumChatFormatting.BOLD.toString()
		, STRIKETHROUGH = EnumChatFormatting.STRIKETHROUGH.toString()
		, UNDERLINE = EnumChatFormatting.UNDERLINE.toString()
		, ITALIC = EnumChatFormatting.ITALIC.toString()
		, RESET = EnumChatFormatting.RESET.toString()
		, RESET_TOOLTIP = RESET + GRAY
		;
	}
}